/* Procedure para gerao de contas a pagar */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_CONTAPAGAR' AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID              AND
	        U.NAME = USER)
  DROP PROCEDURE GERA_CONTAPAGAR
  GO
CREATE PROCEDURE GERA_CONTAPAGAR
   @P_CDFILIAL   VARCHAR(04),
   @P_CDFORNECED VARCHAR(21),
   @P_NRLANCTONF VARCHAR(20),
   @P_IDTIPOLANC VARCHAR(01)
AS
   DECLARE @V_CDFORMPGTO   VARCHAR(02);
   DECLARE @V_TIPOFORMPGTO VARCHAR(01);
   DECLARE @V_PARCPGTOFO   INTEGER;
   DECLARE @V_VRNOTAFISC   FLOAT;
   DECLARE @V_IDTIPODTPGTO VARCHAR(04);
   DECLARE @V_VRIMPORETI   INTEGER;
   DECLARE @V_SEQUENCIAL   INTEGER;
   DECLARE @V_VRPARCVENC   FLOAT;
   DECLARE @V_VRPARCAUXI   INTEGER;
   DECLARE @V_NRPARCELAS   INTEGER;
   DECLARE @V_DTEMISSAO    DATETIME;
   DECLARE @V_DTENTRSAID   DATETIME;
   DECLARE @V_DATABASE     DATETIME;
   DECLARE @V_DTAUXILIAR   DATETIME;
   DECLARE @V_STAUXILIAR   VARCHAR(10);
   DECLARE @V_NRDIAPGTOVAR VARCHAR(02);
   DECLARE @V_NRMESFORMPGT INTEGER;
   DECLARE @V_NRNUMMESPGTO INTEGER;
   DECLARE @V_VERIFMES     INTEGER;
   DECLARE @V_INDIAS       INTEGER;
   DECLARE @V_NUMERODIAS   INTEGER;
   DECLARE @V_NUMERODIAAUX INTEGER;
   DECLARE @V_STDIAS       VARCHAR(02);
   DECLARE @V_IDTPPERIODO  VARCHAR(01);
   DECLARE @V_IDUTDIAPGTFO VARCHAR(01);
   DECLARE @V_NRDIAPGFIXFO INTEGER;
   DECLARE @V_CDFILDEST    VARCHAR(04);
   DECLARE @V_NRAUTOFORN   VARCHAR(10);
   DECLARE @V_VRPERCPGTOFO FLOAT;
   DECLARE @V_NRDIASPGTOFO INTEGER;
   DECLARE @V_NRDIASPGTOAF INTEGER;
   DECLARE @V_VRPERCPGTOAF FLOAT;
   DECLARE @V_NRDIAFIXAUX  INTEGER;
   DECLARE @w_R            CHAR(1);
   DECLARE @w_F            CHAR(1);
BEGIN
   SET @V_NUMERODIAS = 0;
   SET @V_NUMERODIAAUX = 0;
   SET @W_R = 'R';
   SET @W_F = 'F';

   DELETE FROM CONTAPAGAR
   WHERE (CDFILIAL   = @P_CDFILIAL) AND
         (NRLANCTONF = @P_NRLANCTONF);

   SELECT @V_VRNOTAFISC = VRNOTAFISC,
          @V_DTEMISSAO  = DTEMISSAO,
          @V_DTENTRSAID = DTENTRSAID
   FROM NOTAFISCAL
   WHERE (CDFILIAL   = @P_CDFILIAL) AND
         (NRLANCTONF = @P_NRLANCTONF);

   SELECT @V_VRIMPORETI = SUM(VRTOTIMPONF)
   FROM IMPOSNFTOT INF, IMPOSTO I
   WHERE (INF.CDFILIAL   = @P_CDFILIAL)   AND
         (INF.NRLANCTONF = @P_NRLANCTONF) AND
         (INF.CDIMPOSTO  = I.CDIMPOSTO)   AND
         (I.IDTRATIMPO   = @W_R)          AND
         (I.IDDESCRFONTE   = @W_R);

   IF (@V_VRIMPORETI IS NULL) BEGIN
      SET @V_VRIMPORETI = 0;
   END;

   SET @V_VRNOTAFISC = ROUND(@V_VRNOTAFISC - @V_VRIMPORETI,2);

   IF (@P_IDTIPOLANC = @W_F) BEGIN
      SELECT @V_TIPOFORMPGTO = F.IDTPFORPGTFO,
             @V_PARCPGTOFO   = F.NRPARCPGTOFO,
             @V_IDTIPODTPGTO = FP.IDTIPODTPGTO,
             @V_IDTPPERIODO  = FP.IDTPPERIODO,
             @V_IDUTDIAPGTFO = F.IDUTDIAPGTFO,
             @V_NRDIAPGFIXFO = F.NRDIAPGFIXFO,
             @V_CDFORMPGTO   = FP.CDFORMPGTO
      FROM FORNECEDOR F LEFT JOIN FORMPGTO FP ON (F.CDFORMPGTO = FP.CDFORMPGTO)
      WHERE (F.CDFORNECED = @P_CDFORNECED);
   END
   ELSE BEGIN
      SELECT @V_TIPOFORMPGTO = MAX(A.IDTPFORPGTAF),
             @V_PARCPGTOFO   = MAX(A.NRPARCPGTOAF),
             @V_IDTIPODTPGTO = MAX(FP.IDTIPODTPGTO),
             @V_IDTPPERIODO  = MAX(FP.IDTPPERIODO),
             @V_IDUTDIAPGTFO = MAX(A.IDUTDIAPGTAF),
             @V_NRDIAPGFIXFO = MAX(A.NRDIAPGFIXAF),
             @V_CDFILDEST    = MAX(A.CDFILDEST),
             @V_NRAUTOFORN   = MAX(A.NRAUTOFORN),
             @V_CDFORMPGTO   = MAX(FP.CDFORMPGTO)
      FROM ITEMAUTF I, AUTOFORNE A LEFT JOIN FORMPGTO FP ON (A.CDFORMPGTO = FP.CDFORMPGTO)
      WHERE (I.CDFILLANC  = @P_CDFILIAL)   AND
            (I.NRLANCTONF = @P_NRLANCTONF) AND
            (I.CDFILDEST  = A.CDFILDEST)   AND
            (I.CDFILLANC  = A.CDFILLANC)   AND
            (I.NRAUTOFORN = A.NRAUTOFORN);
   END;
   
	/* Rotina para calcular o nmero de dias de prazo */
   IF (NOT @V_TIPOFORMPGTO IS NULL) BEGIN
      IF (@V_TIPOFORMPGTO = 'V') BEGIN
         IF (@V_IDTIPODTPGTO = 'EMIN') BEGIN
            SET @V_INDIAS = 0;
            SET @V_DATABASE = @V_DTEMISSAO;
         END
         ELSE IF (@V_IDTIPODTPGTO = 'EMEX') BEGIN
            SET @V_INDIAS = 1;
            SET @V_DATABASE = @V_DTEMISSAO;
         END
         ELSE IF (@V_IDTIPODTPGTO = 'ENIN') BEGIN
            SET @V_INDIAS = 0;
            SET @V_DATABASE = @V_DTENTRSAID;
         END
         ELSE IF (@V_IDTIPODTPGTO = 'ENEX') BEGIN
            SET @V_INDIAS = 1;
            SET @V_DATABASE = @V_DTENTRSAID;
         END;
         SET @V_DTAUXILIAR = @V_DATABASE + @V_INDIAS;

         IF (@V_IDTPPERIODO = 'M') BEGIN
            SET @V_STAUXILIAR = RIGHT('00'+CONVERT(VARCHAR, DAY(@V_DTAUXILIAR)), 2);
            SELECT @V_NRDIAPGTOVAR = MAX(NRDIAPGTOVAR),
                   @V_NRMESFORMPGT = MAX(NRMESFORMPGT),
                   @V_NRNUMMESPGTO = ISNULL(MAX(NRNUMMESPGTO), 1)
            FROM DIAPGTO
            WHERE (CDFORMPGTO   =  @V_CDFORMPGTO) AND
                  (NRDIAINIPGTO <= @V_STAUXILIAR) AND
                  (NRDIAFINPGTO >= @V_STAUXILIAR);

            IF (@V_NRMESFORMPGT = 0) BEGIN
            	SET @V_VERIFMES = 0;
            END
            ELSE BEGIN
            	SET @V_VERIFMES = @V_NRNUMMESPGTO;
            END;

            IF (NOT @V_NRDIAPGTOVAR IS NULL) BEGIN
               EXEC VERIFICA_DATA @V_NRDIAPGTOVAR, @V_DTAUXILIAR, @V_VERIFMES, @V_STDIAS OUTPUT;
               SET @V_STAUXILIAR = CONVERT(VARCHAR, @V_DTAUXILIAR, 103);

               SET @V_STAUXILIAR = @V_STDIAS + SUBSTRING(@V_STAUXILIAR, 3, 8);

               SET @V_DTAUXILIAR = CONVERT(VARCHAR, @V_STAUXILIAR, 103);

               IF (@V_NRMESFORMPGT <> 0) BEGIN
                  SET @V_DTAUXILIAR = DATEADD(MM, @V_NRNUMMESPGTO, @V_DTAUXILIAR);
               END;
            END;
         END
         ELSE BEGIN
            SET @V_STDIAS = RIGHT('00'+CONVERT(VARCHAR, DATEPART(DW, @V_DTAUXILIAR)), 2);
            SET @V_INDIAS = CAST(@V_STDIAS AS INTEGER);

            SELECT @V_NRDIAPGTOVAR = MAX(NRDIAPGTOVAR),
                   @V_NRMESFORMPGT = MAX(NRMESFORMPGT)
            FROM DIAPGTO
            WHERE (CDFORMPGTO   =  @V_CDFORMPGTO) AND
                  (NRDIAINIPGTO <= @V_STAUXILIAR) AND
                  (NRDIAFINPGTO >= @V_STAUXILIAR);
                  
            IF (@V_NRDIAPGTOVAR IS NOT NULL) BEGIN
               IF (@V_NRMESFORMPGT = 0) BEGIN
                  IF (@V_INDIAS = CAST(@V_NRDIAPGTOVAR AS INTEGER)) BEGIN
                     SET @V_DTAUXILIAR = @V_DTAUXILIAR + 7;
                  END
                  ELSE BEGIN
                     WHILE CAST(CONVERT(VARCHAR, DAY(@V_DTAUXILIAR)) AS INTEGER) <> CAST(@V_NRDIAPGTOVAR AS INTEGER) BEGIN
                        SET @V_DTAUXILIAR = @V_DTAUXILIAR + 1;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF @V_INDIAS = CAST(@V_NRDIAPGTOVAR AS INTEGER) BEGIN
                     SET @V_DTAUXILIAR = @V_DTAUXILIAR + 7;
                  END
                  ELSE BEGIN
                     IF (@V_INDIAS < CAST(@V_NRDIAPGTOVAR AS INTEGER)) BEGIN
                        SET @V_DTAUXILIAR = @V_DTAUXILIAR + 7;
                     END
                     WHILE CAST(CONVERT(VARCHAR, DAY(@V_DTAUXILIAR)) AS INTEGER) <> CAST(@V_NRDIAPGTOVAR AS INTEGER) BEGIN
                        SET @V_DTAUXILIAR = @V_DTAUXILIAR + 1;
                     END;
                  END;
               END;
            END;
         END;
         SET @V_DTAUXILIAR = @V_DTAUXILIAR - 1;
      END
      ELSE BEGIN
         SET @V_DATABASE   = @V_DTEMISSAO;
         SET @V_DTAUXILIAR = @V_DATABASE;

         IF (@V_IDUTDIAPGTFO = 'I') AND
            (@V_NRDIAPGFIXFO >= CAST(CONVERT(VARCHAR, DAY(@V_DTAUXILIAR)) AS INTEGER)) BEGIN
   	    SET @V_NRDIAFIXAUX = RIGHT('00'+CONVERT(VARCHAR, @V_NRDIAPGFIXFO), 2);
            EXEC VERIFICA_DATA @V_NRDIAFIXAUX, @V_DTAUXILIAR, 0, @V_STDIAS OUTPUT;
            SET @V_STAUXILIAR = @V_STDIAS + SUBSTRING(CONVERT(VARCHAR,@V_DTAUXILIAR,103), 3, 8);

            SET @V_DTAUXILIAR = CONVERT(VARCHAR, @V_STAUXILIAR, 103);
         END
         ELSE BEGIN
            SET @V_DTAUXILIAR = DATEADD(MM, 1, @V_DTAUXILIAR);
   	    SET @V_NRDIAFIXAUX = RIGHT('00'+CONVERT(VARCHAR, @V_NRDIAPGFIXFO), 2);
            EXEC VERIFICA_DATA @V_NRDIAFIXAUX, @V_DTAUXILIAR, 0, @V_STDIAS OUTPUT;
            SET @V_STAUXILIAR = @V_STDIAS + SUBSTRING(CONVERT(VARCHAR,@V_DTAUXILIAR,103), 3, 8);

            SET @V_DTAUXILIAR = CONVERT(VARCHAR, @V_STAUXILIAR, 103);
         END;
      END;
      SET @V_NUMERODIAS = DATEDIFF(DY,@V_DATABASE, @V_DTAUXILIAR);

      IF @V_NUMERODIAS < 0 BEGIN
         SET @V_NUMERODIAS = 0;
      END;
   END;
/* Incluso na tabela de contas a receber de acordo com
   a forma de pagamento do fornecedor
*/

   IF (@V_TIPOFORMPGTO IS NULL) BEGIN /*Sem forma de pagamento definida*/
      INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                              CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                              NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                              VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                              IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
      VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
              NULL, NULL, '01',
              '00', 0, @V_DTENTRSAID,
              @V_VRNOTAFISC, @V_DTENTRSAID, @V_VRNOTAFISC,
              'A', NULL, NULL, NULL);
   END
   ELSE IF (@V_TIPOFORMPGTO = @W_F) BEGIN /*Forma de pagamento fixa*/
      IF (@V_PARCPGTOFO = 1) BEGIN
         INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                 CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                                 NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                                 VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                                 IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
         VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                 NULL, NULL, '01',
                 '00', @V_NUMERODIAS, @V_DTAUXILIAR,
                 @V_VRNOTAFISC, @V_DTENTRSAID, @V_VRNOTAFISC,
                 'A', NULL, NULL, NULL);
      END
      ELSE BEGIN
         SET @V_SEQUENCIAL = 1;
         SET @V_VRPARCVENC = ROUND(@V_VRNOTAFISC/@V_PARCPGTOFO,2);
         SET @V_DTAUXILIAR = @V_DATABASE + @V_NUMERODIAS;
         WHILE (@V_SEQUENCIAL <= @V_PARCPGTOFO) BEGIN
            IF (@V_SEQUENCIAL = @V_PARCPGTOFO) BEGIN
               SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND(@V_VRNOTAFISC - (@V_VRPARCVENC * @V_PARCPGTOFO), 2);
            END;
            INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                    CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                                    NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                                    VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                                    IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
            VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                    NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL),2),
                    '00', @V_NUMERODIAS, @V_DTAUXILIAR,
                    @V_VRPARCVENC, @V_DTAUXILIAR, @V_VRPARCVENC,
                    'A', NULL, NULL, NULL);
            
            SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
            SET @V_DTAUXILIAR = DATEADD(MM, 1, @V_DTAUXILIAR);
            SET @V_NUMERODIAS = DATEDIFF(DY,@V_DATABASE, @V_DTAUXILIAR);
            IF @V_NUMERODIAS < 0 BEGIN
               SET @V_NUMERODIAS = 0;
            END;
         END;
      END;
   END
   ELSE BEGIN /*Forma de pagamento varivel*/
      IF (@P_IDTIPOLANC = @W_F) BEGIN
         SELECT @V_NRPARCELAS = COUNT(*)
         FROM PRAZOPGTFORN
         WHERE (CDFORNECED = @P_CDFORNECED);
      END
      ELSE BEGIN
         SELECT @V_NRPARCELAS = COUNT(*)
         FROM PRAZOPGTAF
         WHERE (CDFILLANC  = @P_CDFILIAL)  AND
               (CDFILDEST  = @V_CDFILDEST) AND
               (NRAUTOFORN = @V_NRAUTOFORN);
      END;

      SET @V_DTAUXILIAR = @V_DATABASE + @V_NUMERODIAS;

      IF (@V_NRPARCELAS = 1) BEGIN
         IF (@P_IDTIPOLANC = @W_F) BEGIN
            SELECT @V_INDIAS = ISNULL(NRDIASPGTOFO, 0)
            FROM PRAZOPGTFORN
            WHERE (CDFORNECED = @P_CDFORNECED);

            SET @V_NUMERODIAS = @V_NUMERODIAS + @V_INDIAS;
            SET @V_DTAUXILIAR = @V_DTAUXILIAR + @V_INDIAS;
         END
         ELSE BEGIN
            SELECT @V_INDIAS = ISNULL(NRDIASPGTOAF, 0)
            FROM PRAZOPGTAF
            WHERE (CDFILLANC  = @P_CDFILIAL)  AND
                  (CDFILDEST  = @V_CDFILDEST) AND
                  (NRAUTOFORN = @V_NRAUTOFORN);
                  
            SET @V_NUMERODIAS = @V_NUMERODIAS + @V_INDIAS;
            SET @V_DTAUXILIAR = @V_DTAUXILIAR + @V_INDIAS;
         END

         INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                 CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                                 NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                                 VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                                 IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
         VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                 NULL, NULL, '01',
                 '00',@V_NUMERODIAS, @V_DTAUXILIAR,
                 @V_VRNOTAFISC, @V_DTAUXILIAR, @V_VRNOTAFISC,
                 'A', NULL, NULL, NULL);
      END
      ELSE BEGIN
         SET @V_SEQUENCIAL = 1;
         SET @V_VRPARCAUXI = 0;

         IF (@P_IDTIPOLANC = @W_F) BEGIN
            DECLARE C_PARCELAS CURSOR FOR
            SELECT VRPERCPGTOFO, NRDIASPGTOFO
            FROM PRAZOPGTFORN
            WHERE (CDFORNECED = @P_CDFORNECED)
            OPEN C_PARCELAS;
            FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO, @V_NRDIASPGTOFO;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOFO/100)), 2);
               SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

               IF (@V_SEQUENCIAL = @V_NRPARCELAS) BEGIN
                  SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI), 2);
               END;

               IF (@V_NRDIASPGTOFO = 0) BEGIN
                  SET @V_NUMERODIAS = @V_NUMERODIAS + 1;
               END
               ELSE BEGIN
                  SET @V_NUMERODIAS = @V_NUMERODIAS + @V_NRDIASPGTOFO - @V_NUMERODIAAUX;
               END;

               SET @V_DTAUXILIAR = @V_DATABASE + @V_NUMERODIAS;

               INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                       CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                                       NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                                       VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                                       IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
               VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                       NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL),2),
                       '00', @V_NUMERODIAS, @V_DTAUXILIAR,
                       @V_VRPARCVENC, @V_DTAUXILIAR, @V_VRPARCVENC,
                       'A', NULL, NULL, NULL);

               SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
               SET @V_NUMERODIAAUX = @V_NRDIASPGTOFO;
               FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO, @V_NRDIASPGTOFO;
            END;
            CLOSE C_PARCELAS;
            DEALLOCATE C_PARCELAS;
         END
         ELSE BEGIN
            SET @V_NUMERODIAAUX = @V_NUMERODIAS;
            DECLARE C_PARCELAS CURSOR FOR
            SELECT NRDIASPGTOAF, VRPERCPGTOAF
            FROM PRAZOPGTAF
            WHERE (CDFILLANC  = @P_CDFILIAL)  AND
                  (CDFILDEST  = @V_CDFILDEST) AND
                  (NRAUTOFORN = @V_NRAUTOFORN)
            OPEN C_PARCELAS;
            FETCH NEXT FROM C_PARCELAS INTO @V_NRDIASPGTOAF, @V_VRPERCPGTOAF;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOAF/100)),2);
               SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

               IF (@V_SEQUENCIAL = @V_NRPARCELAS) BEGIN
                  SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
               END;

               IF (@V_NRDIASPGTOAF = 0) BEGIN
                  SET @V_NUMERODIAAUX = @V_NUMERODIAS + 1;
               END
               ELSE BEGIN
                  SET @V_NUMERODIAAUX = @V_NUMERODIAS + @V_NRDIASPGTOAF;
               END;

               SET @V_DTAUXILIAR = @V_DATABASE + @V_NUMERODIAAUX;

               INSERT INTO CONTAPAGAR (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                       CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                                       NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                                       VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                                       IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
               VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                       NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL), 2),
                       '00', @V_NUMERODIAS, @V_DTAUXILIAR,
                       @V_VRPARCVENC, @V_DTAUXILIAR, @V_VRPARCVENC,
                       'A', NULL, NULL, NULL);

               SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
               FETCH NEXT FROM C_PARCELAS INTO @V_NRDIASPGTOAF, @V_VRPERCPGTOAF;
            END;
            CLOSE C_PARCELAS;
            DEALLOCATE C_PARCELAS;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_CONTAPAGAR','5.05.077';
GO
